SystemOrganization addCategory: #Prototalk!
SystemOrganization addCategory: #'Prototalk-Tests'!

CodAMetaComponent subclass: #ProtoTalkComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototalk'!

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 18:03'!
addMethod: code for: anObject
	anObject meta anonymClass compile: code! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 18:23'!
at: id for: anObject
	^anObject slots at: id ifAbsent: []! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 18:23'!
at: id put: value for: anObject
	anObject slots at: id put: value.! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 18:24'!
installingOn: aSymbol for: anObject
	aSymbol = #Store ifTrue: [
		anObject meta anonymClass addInstanceVarNamed: 'slots' withValue: Dictionary new.].
	self addMethod: 'slots
	^slots ifNil: [slots := Dictionary new]' for: anObject.
	self addMethod: 'slots: val
	slots := val' for: anObject! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 18:54'!
methodFor: aMessage for: anObject
	^ anObject meta anonymClass compiledMethodAt: aMessage selector ifAbsent: [
		anObject meta oldObject class allCompiledMethodsAt: aMessage selector ]! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 18:23'!
slotIdsFor: anObject
	^anObject slots keys.! !

!Object methodsFor: '*prototalk' stamp: 'je 1/25/2008 17:53'!
addMethod: code
	self withExtendableMeta protocol = ProtoTalkComponent ifFalse: [
		self meta install: ProtoTalkComponent at: #Protocol for: self ].
	self withExtendableMeta protocol addMethod: code for: self! !

!Object methodsFor: '*prototalk' stamp: 'je 1/25/2008 18:27'!
protoClone
	| clone |
	clone := Object new.
	clone withExtendableMeta install: ProtoTalkComponent at: #Protocol for: clone.
	clone withExtendableMeta install: ProtoTalkComponent at: #State for: clone.
	clone withExtendableMeta state at: #prototype put: self for: clone.
	self class instVarNames do: [ :name | clone withExtendableMeta state at: name asSymbol put: (self instVarNamed: name asSymbol) for: clone].
	^clone! !

!Object methodsFor: '*prototalk' stamp: 'je 1/25/2008 18:27'!
slotIds
	^ self meta state slotIdsFor: self! !

!Class methodsFor: '*prototalk' stamp: 'je 1/18/2008 18:53'!
allCompiledMethodsAt: aSelector
	self compiledMethodAt: aSelector ifPresent: [ :method | ^method].
	self allSuperclassesDo: [ :superClass |
		superClass compiledMethodAt: aSelector ifPresent: [ :method| ^method]].
	Error signal: 'key not found'! !

!Class methodsFor: '*prototalk' stamp: 'je 1/18/2008 18:54'!
compiledMethodAt: aSelector ifPresent: aBlock
	^self methodDict at: aSelector ifPresent: aBlock! !

TestCase subclass: #ProtoTalkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototalk-Tests'!

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 18:28'!
testClone
	| blub blubsClone |
	blub := Morph new.
	blubsClone := blub protoClone.
	blub class instVarNames do: [:id | self assert: (blubsClone slotIds includes: id)]
! !

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 18:02'!
testObjectMethods
	| o1 |
	o1 := 'Juri'.
	o1 addMethod: 'huhu
'.

	self shouldnt: [o1 huhu] raise: MessageNotUnderstood.
	self assert: ((o1 at: 1) = $J)
! !
